Index: CKEditor/branches/versions/3.3.x/_source/plugins/scayt/dialogs/options.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/scayt/dialogs/options.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/scayt/dialogs/options.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/scayt/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -13,5 +13,6 @@
 	var commandName 	= 'scaytcheck',
 		openPage		= '',
-		scayt_paused	= null;
+		scayt_paused	= null,
+		scayt_control_id = null;
 
 	// Checks if a value exists in an array
@@ -38,20 +39,26 @@
 			// Initialise Scayt instance.
 			var oParams = {};
-			oParams.srcNodeRef = editor.document.getWindow().$.frameElement; 		// Get the iframe.
+			// Get the iframe.
+			oParams.srcNodeRef = editor.document.getWindow().$.frameElement;
 			// syntax : AppName.AppVersion@AppRevision
 			oParams.assocApp  = "CKEDITOR." + CKEDITOR.version + "@" + CKEDITOR.revision;
 			oParams.customerid = editor.config.scayt_customerid  || "1:WvF0D4-UtPqN1-43nkD4-NKvUm2-daQqk3-LmNiI-z7Ysb4-mwry24-T8YrS3-Q2tpq2";
-			oParams.customDictionaryIds = editor.config.scayt_customDictionaryIds;
-			oParams.userDictionaryName = editor.config.scayt_userDictionaryName;
+			oParams.customDictionaryIds = editor.config.scayt_customDictionaryIds || '';
+			oParams.userDictionaryName = editor.config.scayt_userDictionaryName || '';
 			oParams.sLang = editor.config.scayt_sLang || "en_US";
-
-			if ( CKEDITOR._scaytParams )
-			{
-				for ( var k in CKEDITOR._scaytParams )
-				{
-					oParams[ k ] = CKEDITOR._scaytParams[ k ];
+			
+
+			var scayt_custom_params = window.scayt_custom_params;
+			if ( typeof scayt_custom_params == 'object')
+			{
+				for ( var k in scayt_custom_params )
+				{
+					oParams[ k ] = scayt_custom_params[ k ];
 				}
 			}
-
+			
+			if ( scayt_control_id )
+				oParams.id = scayt_control_id;
+			
 			var scayt_control = new window.scayt( oParams );
 
@@ -73,5 +80,5 @@
 
 			for (var i = 0,l=4; i<l; i++)
-				fTabs.push( uiTabs[i] && plugin.uiTabs[i] );
+			    fTabs.push( uiTabs[i] && plugin.uiTabs[i] );
 
 			plugin.uiTabs = fTabs;
@@ -110,5 +117,6 @@
 					{
 						scayt_paused = scayt_instanse.paused = !scayt_instanse.disabled;
-						scayt_instanse.destroy();
+						scayt_control_id = scayt_instanse.id;
+						scayt_instanse.destroy( true );
 						delete plugin.instances[ editor.name ];
 					}
@@ -119,11 +127,13 @@
 		editor.on( 'destroy', function()
 			{
-				plugin.getScayt( editor ).destroy();
+				scayt_control_id = scayt_instanse.id;
+				plugin.getScayt( editor ).destroy( true );
 			});
 		// Listen to data manipulation to reflect scayt markup.
 		editor.on( 'afterSetData', function()
 			{
-				if ( plugin.isScaytEnabled( editor ) )
-					plugin.getScayt( editor ).refresh();
+				if ( plugin.isScaytEnabled( editor ) ) {
+					window.setTimeout( function(){ plugin.getScayt( editor ).refresh() }, 10 );
+				}
 			});
 
@@ -140,8 +150,5 @@
 
 					// Swallow any SCAYT engine errors.
-					try{
-						scayt_instance.refresh();
-					}catch( er )
-					{}
+					window.setTimeout( function(){ scayt_instance.refresh() }, 10 );
 				}
 			}, this, null, 50 );
@@ -159,8 +166,7 @@
 
 					// Swallow any SCAYT engine errors.
-					try{
-						scayt_instance.refresh();
-					}catch( er )
-					{}
+					
+					window.setTimeout( function(){ scayt_instance.refresh() },10 );
+					
 				}
 			}, this, null, 50 );
@@ -219,4 +225,7 @@
 		loadEngine : function( editor )
 		{
+			// SCAYT doesn't work with Opera.
+			if ( CKEDITOR.env.opera )
+				return;
 			if ( this.engineLoaded === true )
 				return onEngineLoad.apply( editor );	// Add new instance.
@@ -231,5 +240,6 @@
 				this,
 				null,
-				0 );	// First to run.
+				0 
+			);	// First to run.
 
 			this.engineLoaded = -1;	// Loading in progress.
@@ -239,5 +249,5 @@
 			// Default to 'http' for unknown.
 			protocol = protocol.search( /https?:/) != -1? protocol : 'http:';
-			var baseUrl  = "svc.spellchecker.net/spellcheck3/lf/scayt/scayt21.js";
+			var baseUrl  = "svc.spellchecker.net/spellcheck31/lf/scayt/scayt22.js";
 
 			var scaytUrl  =  editor.config.scayt_srcUrl || ( protocol + "//" + baseUrl );
@@ -356,5 +366,6 @@
 			confuiTabs = confuiTabs.split(",");
 			// check array length ! allwaays must be 3 filled with 1 or 0
-			for (var i=0,l=3; i<l; i++){
+			for (var i=0,l=3; i<l; i++)
+			{
 				var flag = parseInt(confuiTabs[i] || "1" ,10);
 				uiTabs.push(  flag  );
@@ -458,11 +469,16 @@
 			if ( editor.contextMenu && editor.addMenuItems )
 			{
-				editor.contextMenu.addListener( function( element )
-					{
-						if ( !( plugin.isScaytEnabled( editor ) && element ) )
+				editor.contextMenu.addListener( function(  )
+					{
+						if ( !plugin.isScaytEnabled( editor ) )
 							return null;
 
 						var scayt_control = plugin.getScayt( editor ),
-							word = scayt_control.getWord( element.$ );
+							node = scayt_control.getScaytNode();
+						
+						if ( !node )
+							return null;
+
+							var word = scayt_control.getWord( node );
 
 						if ( !word )
@@ -472,5 +488,5 @@
 							_r = {},
 							items_suggestion = window.scayt.getSuggestion( word, sLang );
-						if (!items_suggestion || !items_suggestion.length )
+						if ( !items_suggestion || !items_suggestion.length )
 							return null;
 						// Remove unused commands and menuitems
@@ -509,5 +525,5 @@
 										}
 									};
-								})( element.$, items_suggestion[i] );
+								})( node, items_suggestion[i] );
 
 							if ( i < maxSuggestions )
@@ -547,5 +563,5 @@
 							var ignore_command = {
 								exec: function(){
-									scayt_control.ignore(element.$);
+									scayt_control.ignore( node );
 								}
 							};
@@ -558,5 +574,5 @@
 							var ignore_all_command = {
 								exec: function(){
-									scayt_control.ignoreAll(element.$);
+									scayt_control.ignoreAll( node );
 								}
 							};
@@ -569,5 +585,5 @@
 							var addword_command = {
 								exec: function(){
-									window.scayt.addWordToUserDictionary(element.$);
+									window.scayt.addWordToUserDictionary( node );
 								}
 							};
@@ -592,12 +608,146 @@
 				};
 				editor.on( 'showScaytState', showInitialState );
-
 				plugin.loadEngine( editor );
 			}
+
+			// Prevent word marker line from displaying in elements path. (#3570)
+			var elementsPathFilters;
+			if ( elementsPathFilters = editor.config.elementsPath_filters )
+			{
+				elementsPathFilters.push( function( element )
+				{
+					if ( element.hasAttribute( 'scaytid' ) )
+						return false;
+				} );
+			}
+
 		}
 	});
 })();
 
-// TODO: Documentation
-// CKEDITOR.config.scayt_maxSuggestions
-// CKEDITOR.config.scayt_autoStartup
+/**
+ * If enabled (true), turns on SCAYT automatically after loading the editor.
+ * @name CKEDITOR.config.scayt_autoStartup
+ * @type Boolean
+ * @default false
+ * @example
+ * config.scayt_autoStartup = true;
+ */
+
+/**
+ * Defines the number of SCAYT suggestions to show in the main context menu.
+ * The possible values are:
+ * <ul>
+ *	<li>0 (zero): All suggestions are displayed in the main context menu.</li>
+ *	<li>Positive number: The maximum number of suggestions to shown in context
+ *		menu. Other entries will be shown in "More Suggestions" sub-menu.</li>
+ *	<li>Negative number: No suggestions are shown in the main context menu. All
+ *		entries will be listed in the "Suggestions" sub-menu.</li>
+ * </ul>
+ * @name CKEDITOR.config.scayt_maxSuggestions
+ * @type Number
+ * @default 5
+ * @example
+ * // Display only three suggestions in the main context menu.
+ * config.scayt_maxSuggestions = 3;
+ * @example
+ * // Do not show the suggestions directly.
+ * config.scayt_maxSuggestions = -1;
+ */
+
+/**
+ * Sets the customer ID for SCAYT. Required for migration from free version 
+ * with banner to paid version.
+ * @name CKEDITOR.config.scayt_customerid
+ * @type String
+ * @default ''
+ * @example
+ * // Load SCAYT using my customer ID.
+ * config.scayt_customerid  = 'your-encrypted-customer-id';
+ */
+
+/**
+ * Enables/disables the "More Suggestions" sub-menu in the context menu.
+ * The possible values are "on" or "off".
+ * @name CKEDITOR.config.scayt_moreSuggestions
+ * @type String
+ * @default 'on'
+ * @example
+ * // Disables the "More Suggestions" sub-menu.
+ * config.scayt_moreSuggestions = 'off';
+ */
+
+/**
+ * Customizes the display of SCAYT context menu commands ("Add Word", "Ignore"
+ * and "Ignore All"). It must be a string with one or more of the following
+ * words separated by a pipe ("|"):
+ * <ul>
+ *	<li>"off": disables all options.</li>
+ *	<li>"all": enables all options.</li>
+ *	<li>"ignore": enables the "Ignore" option.</li>
+ *	<li>"ignoreall": enables the "Ignore All" option.</li>
+ *	<li>"add": enables the "Add Word" option.</li>
+ * </ul>
+ * @name CKEDITOR.config.scayt_contextCommands
+ * @type String
+ * @default 'all'
+ * @example
+ * // Show only "Add Word" and "Ignore All" in the context menu.
+ * config.scayt_contextCommands = 'add|ignoreall';
+ */
+
+/**
+ * Sets the default spellchecking language for SCAYT.
+ * @name CKEDITOR.config.scayt_sLang
+ * @type String
+ * @default 'en_US'
+ * @example
+ * // Sets SCAYT to German.
+ * config.scayt_sLang = 'de_DE';
+ */
+
+/**
+ * Sets the visibility of the SCAYT tabs in the settings dialog and toolbar
+ * button. The value must contain a "1" (enabled) or "0" (disabled) number for
+ * each of the following entries, in this precise order, separated by a
+ * comma (","): "Options", "Languages" and "Dictionary".
+ * @name CKEDITOR.config.scayt_uiTabs
+ * @type String
+ * @default '1,1,1'
+ * @example
+ * // Hide the "Languages" tab.
+ * config.scayt_uiTabs = '1,0,1';
+ */
+
+
+/**
+ * Set the URL to SCAYT core. Required to switch to licensed version of SCAYT application.
+ * Further details at http://wiki.spellchecker.net/doku.php?id=3rd:wysiwyg:fckeditor:wscckf3l .
+ * @name CKEDITOR.config.scayt_srcUrl
+ * @type String
+ * @default ''
+ * @example
+ * config.scayt_srcUrl = "http://my-host/spellcheck/lf/scayt/scayt.js";
+ */
+
+/**
+ * Links SCAYT to custom dictionaries. It's a string containing dictionary ids
+ * separared by commas (","). Available only for licensed version. 
+ * Further details at http://wiki.spellchecker.net/doku.php?id=custom_dictionary_support .
+ * @name CKEDITOR.config.scayt_customDictionaryIds
+ * @type String
+ * @default ''
+ * @example
+ * config.scayt_customDictionaryIds = '3021,3456,3478"';
+ */
+
+/**
+ * Makes it possible to activate a custom dictionary on SCAYT. The user
+ * dictionary name must be used. Available only for licensed version.
+ * @name CKEDITOR.config.scayt_userDictionaryName
+ * @type String
+ * @default ''
+ * @example
+ * config.scayt_userDictionaryName = 'MyDictionary';
+ */
+
Index: CKEditor/branches/versions/3.3.x/_source/plugins/selection/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/selection/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/selection/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -73,4 +73,5 @@
 	var selectAllCmd =
 	{
+		modes : { wysiwyg : 1, source : 1 },
 		exec : function( editor )
 		{
@@ -81,5 +82,16 @@
 					break;
 				case 'source' :
-					// TODO
+					// Select the contents of the textarea
+					var textarea = editor.textarea.$ ;
+					if ( CKEDITOR.env.ie )
+					{
+						textarea.createTextRange().execCommand( 'SelectAll' ) ;
+					}
+					else
+					{
+						textarea.selectionStart = 0 ;
+						textarea.selectionEnd = textarea.value.length ;
+					}
+					textarea.focus() ;
 			}
 		},
@@ -109,6 +121,11 @@
 						// possible to restore the selection before click
 						// events get executed.
-						body.on( 'focusin', function()
+						body.on( 'focusin', function( evt )
 							{
+								// If there are elements with layout they fire this event but
+								// it must be ignored to allow edit its contents #4682
+								if ( evt.data.$.srcElement.nodeName != 'BODY' )
+									return;
+
 								// If we have saved a range, restore it at this
 								// point.
@@ -127,5 +144,5 @@
 							});
 
-						editor.window.on( 'focus', function()
+						body.on( 'focus', function()
 							{
 								// Enable selections to be saved.
@@ -135,6 +152,11 @@
 							});
 
-						body.on( 'beforedeactivate', function()
+						body.on( 'beforedeactivate', function( evt )
 							{
+								// Ignore this event if it's caused by focus switch between
+								// internal editable control type elements, e.g. layouted paragraph. (#4682)
+								if ( evt.data.$.toElement )
+									return;
+
 								// Disable selections from being saved.
 								saveEnabled = false;
@@ -709,25 +731,28 @@
 				return cache.selectedElement;
 
-			var node;
-
-			if ( this.getType() == CKEDITOR.SELECTION_ELEMENT )
-			{
-				var sel = this.getNative();
-
-				if ( CKEDITOR.env.ie )
-				{
-					try
-					{
-						node = sel.createRange().item(0);
+			var self = this;
+
+			var node = CKEDITOR.tools.tryThese(
+				// Is it native IE control type selection?
+				function()
+				{
+					return self.getNative().createRange().item( 0 );
+				},
+				// Figure it out by checking if there's a single enclosed
+				// node of the range.
+				function()
+				{
+					var range  = self.getRanges()[ 0 ];
+					range.shrink( CKEDITOR.SHRINK_ELEMENT );
+
+					var enclosed;
+					if ( range.startContainer.equals( range.endContainer )
+						&& ( range.endOffset - range.startOffset ) == 1
+						&& styleObjectElements[ ( enclosed = range.startContainer.getChild( range.startOffset ) ).getName() ] )
+					{
+						return enclosed.$;
 					}
-					catch(e) {}
-				}
-				else
-				{
-					var range = sel.getRangeAt( 0 );
-					node = range.startContainer.childNodes[ range.startOffset ];
-				}
-			}
-
+				});
+			
 			return cache.selectedElement = ( node ? new CKEDITOR.dom.element( node ) : null );
 		},
@@ -820,4 +845,8 @@
 					range.moveToElementText( element.$ );
 					range.select();
+				}
+				finally
+				{
+					this.document.fire( 'selectionchange' );
 				}
 
@@ -1065,4 +1094,6 @@
 				ieRange.select();
 			}
+			
+			this.document.fire( 'selectionchange' );
 		}
 	:
Index: CKEditor/branches/versions/3.3.x/_source/plugins/showblocks/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/showblocks/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/showblocks/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
Index: CKEditor/branches/versions/3.3.x/_source/plugins/showborders/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/showborders/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/showborders/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -130,34 +130,31 @@
 				} );
 			}
+		}
+	});
 
-			// Table dialog must be aware of it.
-			CKEDITOR.on( 'dialogDefinition', function( ev )
-				{
-					if ( ev.editor != editor )
-						return;
+	// Table dialog must be aware of it.
+	CKEDITOR.on( 'dialogDefinition', function( ev )
+	{
+		var dialogName = ev.data.name;
 
-					var dialogName = ev.data.name;
+		if ( dialogName == 'table' || dialogName == 'tableProperties' )
+		{
+			var dialogDefinition = ev.data.definition,
+				infoTab = dialogDefinition.getContents( 'info' ),
+				borderField = infoTab.get( 'txtBorder' ),
+				originalCommit = borderField.commit;
 
-					if ( dialogName == 'table' || dialogName == 'tableProperties' )
+			borderField.commit = CKEDITOR.tools.override( originalCommit, function( org )
+			{
+				return function( data, selectedTable )
 					{
-						var dialogDefinition = ev.data.definition,
-							infoTab = dialogDefinition.getContents( 'info' ),
-							borderField = infoTab.get( 'txtBorder' ),
-							originalCommit = borderField.commit;
+						org.apply( this, arguments );
+						var value = parseInt( this.getValue(), 10 );
+						selectedTable[ ( !value || value <= 0 ) ? 'addClass' : 'removeClass' ]( showBorderClassName );
+					};
+			} );
+		}
+	});
 
-						borderField.commit = CKEDITOR.tools.override( originalCommit, function( org )
-						{
-							return function( data, selectedTable )
-								{
-									org.apply( this, arguments );
-									var value = parseInt( this.getValue(), 10 );
-									selectedTable[ ( !value || value <= 0 ) ? 'addClass' : 'removeClass' ]( showBorderClassName );
-								};
-						} );
-					}
-				});
-		}
-
-	});
 } )();
 
Index: CKEditor/branches/versions/3.3.x/_source/plugins/smiley/dialogs/smiley.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/smiley/dialogs/smiley.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/smiley/dialogs/smiley.js	(revision 5306)
@@ -56,4 +56,5 @@
 
 		var keystroke = ev.getKeystroke();
+		var rtl = editor.lang.dir == 'rtl';
 		switch ( keystroke )
 		{
@@ -87,5 +88,5 @@
 
 			// RIGHT-ARROW
-			case 39 :
+			case rtl ? 37 : 39 :
 			// TAB
 			case 9 :
@@ -108,5 +109,5 @@
 
 			// LEFT-ARROW
-			case 37 :
+			case rtl ? 39 : 37 :
 			// SHIFT + TAB
 			case CKEDITOR.SHIFT + 9 :
@@ -136,5 +137,5 @@
 	[
 		'<div>' +
-		'<span id="smiley_emtions_label" class="cke_voice_label">' + editor.lang.common.options +'</span>',
+		'<span id="smiley_emtions_label" class="cke_voice_label">' + lang.options +'</span>',
 		'<table role="listbox" aria-labelledby="smiley_emtions_label" style="width:100%;height:100%" cellspacing="2" cellpadding="2"',
 		CKEDITOR.env.ie && CKEDITOR.env.quirks ? ' style="position:absolute;"' : '',
@@ -192,5 +193,5 @@
  		},
 		onClick : onClick,
-		style : 'width: 100%; height: 100%; border-collapse: separate;'
+		style : 'width: 100%; border-collapse: separate;'
 	};
 
Index: CKEditor/branches/versions/3.3.x/_source/plugins/smiley/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/smiley/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/smiley/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -10,4 +10,5 @@
 	init : function( editor )
 	{
+		editor.config.smiley_path = editor.config.smiley_path || ( this.path + 'images/' );
 		editor.addCommand( 'smiley', new CKEDITOR.dialogCommand( 'smiley' ) );
 		editor.ui.addButton( 'Smiley',
@@ -23,4 +24,5 @@
  * The base path used to build the URL for the smiley images. It must end with
  * a slash.
+ * @name CKEDITOR.config.smiley_path
  * @type String
  * @default {@link CKEDITOR.basePath} + 'plugins/smiley/images/'
@@ -30,7 +32,4 @@
  * config.smiley_path = '/images/smileys/';
  */
-CKEDITOR.config.smiley_path = CKEDITOR.basePath +
-	'_source/' +		// @Packager.RemoveLine
-	'plugins/smiley/images/';
 
 /**
Index: CKEditor/branches/versions/3.3.x/_source/plugins/sourcearea/plugin.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/sourcearea/plugin.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/sourcearea/plugin.js	(revision 5306)
@@ -1,3 +1,3 @@
-/*
+﻿/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -139,4 +139,5 @@
 						unload : function( holderElement )
 						{
+							textarea.clearCustomData();
 							editor.textarea = textarea = null;
 
Index: CKEditor/branches/versions/3.3.x/_source/plugins/specialchar/dialogs/specialchar.js
===================================================================
--- CKEditor/branches/versions/3.3.x/_source/plugins/specialchar/dialogs/specialchar.js	(revision 5295)
+++ CKEditor/branches/versions/3.3.x/_source/plugins/specialchar/dialogs/specialchar.js	(revision 5306)
@@ -12,4 +12,28 @@
 	var dialog,
 		lang = editor.lang.specialChar;
+	
+	var insertSpecialChar = function ( specialChar )
+	{
+		var selection = editor.getSelection(),
+			ranges	  = selection.getRanges(),
+			range, textNode;
+				
+		editor.fire( 'saveSnapshot' );
+		
+		for ( var i = 0, len = ranges.length ; i < len ; i++ )
+		{
+			range = ranges[ i ];
+			range.deleteContents();
+			
+			textNode =  CKEDITOR.dom.element.createFromHtml( specialChar );
+			range.insertNode( textNode );
+		}
+		
+		range.moveToPosition( textNode, CKEDITOR.POSITION_AFTER_END );
+		range.select();
+		
+		editor.fire( 'saveSnapshot' );
+	};
+	
 	var onChoice = function( evt )
 	{
@@ -24,5 +48,10 @@
 			target.removeClass( "cke_light_background" );
 			dialog.hide();
-			editor.insertHtml( value );
+			
+			// Firefox has bug on insert chars into a element use its own API. (#5170)
+			if ( CKEDITOR.env.gecko )
+				insertSpecialChar( value );
+			else
+				editor.insertHtml( value );
 		}
 	};
@@ -82,4 +111,5 @@
 		var relative, nodeToMove;
 		var keystroke = ev.getKeystroke();
+		var rtl = editor.lang.dir == 'rtl';
 
 		switch ( keystroke )
@@ -120,5 +150,5 @@
 
 			// RIGHT-ARROW
-			case 39 :
+			case rtl ? 37 : 39 :
 			// TAB
 			case 9 :
@@ -154,5 +184,5 @@
 
 			// LEFT-ARROW
-			case 37 :
+			case rtl ? 39 : 37 :
 			// SHIFT + TAB
 			case CKEDITOR.SHIFT + 9 :
@@ -285,5 +315,5 @@
 			}
 
-			html.push( '</tbody></table>', '<span id="specialchar_table_label" class="cke_voice_label">' + editor.lang.common.options +'</span>' );
+			html.push( '</tbody></table>', '<span id="specialchar_table_label" class="cke_voice_label">' + lang.options +'</span>' );
 
 			this.getContentElement( 'info', 'charContainer' ).getElement().setHtml( html.join( '' ) );
